<template xmlns:v-slot="http://www.w3.org/1999/XSL/Transform">
  <validation-provider :rules="validationRules" v-slot="{ errors }" :vid="validationId">
    <q-input
      ref="RMInput"
      square
      :class="mClass"
      :style="styleCss"
      :filled="mainDesign ==='filled'"
      :outlined="mainDesign ==='outlined'"
      :standout="mainDesign ==='standout'"
      :borderless="mainDesign ==='borderless'"
      :standard="mainDesign ==='standard'"
      :dense="dense"
      :autofocus="autofocus"
      :autogrow="autogrow"
      :type="cTypeInput"
      v-model="realValue"
      :error="errors.length !== 0"
      :error-message="errors[0]"
      :bottom-slots="error"
      :clearable="clearable"
      clear-icon="la la-times"
      @blur="blur"
      @keyup.enter="keyupEnter"
      :label="label"
      :hint="hint"
      :readonly="readonly"
      :input-style="inputStyle"
      :hide-bottom-space="hideBottomSpace"
      :disable="disable"
      :suffix="mSuffix"
      :tooltips="tooltips"
    >
      <template v-slot:label>
        <slot name="label">
          {{label}} <span v-if="isRequire">*</span>
        </slot>
      </template>
      <q-tooltip v-if="tooltips" >{{ tooltips }}</q-tooltip>
      <template v-slot:before>
        <slot name="mBefore"/>
      </template>

      <template v-slot:prepend>
        <slot name="mPrepend"/>
        <template v-if="typeInput==='date_time' &&  mainDesign!=='borderless'">
          <q-icon name="la la-calendar" class="cursor-pointer">
            <q-popup-proxy ref="qDateProxy" transition-show="scale" transition-hide="scale">
              <q-date v-model="inputDate" today-btn  @input="() => $refs.qDateProxy.hide()"/>
            </q-popup-proxy>
          </q-icon>
        </template>
      </template>

      <template v-slot:append>
        <slot name="mAppend">
          <template v-if="typeInput==='date' &&  mainDesign!=='borderless'">
            <q-icon name="la la-calendar" class="cursor-pointer">
              <q-popup-proxy ref="qDateProxy" transition-show="scale" transition-hide="scale">
                <q-date v-model="inputDate" today-btn @input="() => $refs.qDateProxy.hide()"/>
              </q-popup-proxy>
            </q-icon>
          </template>

          <template v-if="typeInput==='date_time' &&  mainDesign!=='borderless'">
            <q-icon name="la la-clock" class="cursor-pointer">
              <q-popup-proxy transition-show="scale" transition-hide="scale">
                <q-time v-model="inputDate" now-btn  format24h/>
              </q-popup-proxy>
            </q-icon>
          </template>
        </slot>
      </template>

      <template v-slot:after>
        <slot name="mAfter"/>
      </template>

      <template v-slot:error>
        <slot name="mError"/>
      </template>

    </q-input>
  </validation-provider>
</template>

<script>
import moment from 'moment'


  const toFormats =  {
    date_time: 'DD/MM/YYYY HH:mm',
    date: 'DD/MM/YYYY',
    time: 'HH:mm',
  }
  const fromFormats =  {
    date_time: 'YYYY/MM/DD HH:mm',
    date: 'YYYY/MM/DD',
    time: 'HH:mm',
  }

  export default {
    name: 'MField',
    model: {
      prop: 'value',
      event: 'input',
    },
    props: {
      labelWidth: Number,
      mSuffix: String,
      standout: [Boolean, String],
      inputStyle: [Array, String, Object],
      validationRules: {
        type: [String],
        default: ''
      },
      mClass: [Array, String, Object],
      styleCss: [String, Object],
      outlined: {
        type: Boolean,
        default: true,
      },
      clearable: {
        type: Boolean,
        default: false,
      },
      hideBottomSpace: {
        type: Boolean,
        default: false,
      },
      value: {
        type: [String, Number, Object,Date],
      },
      inset: String,
      error: {
        type: Boolean,
        default: false,
      },
      tooltips: {
        type: String,
        default: '',
      },
      disable: {
        type: Boolean,
        default: false,
      },
      autofocus: {
        type: Boolean,
        default: false,
      },
      dense: {
        type: Boolean,
        default: true,
      },
      autogrow: {
        type: Boolean,
        default: false,
      },
      errorMessage: String,
      readonly: {
        type: Boolean,
        default: false,
      },
      label: String,
      typeInput: { // number
        type: String,
        default: 'text',
      },
      hint: String,
      orientation: {
        type: String,
        default: 'horizontal',
      },
      mainDesign: {
        type: String,
        default: 'outlined',
      },
      validationId: {
        type: String,
        default: null,
      },

    },
    data: () => {
      return {
        realValue: null,
        inputDate: null,

      }
    },

    methods: {

      change(val) {
        if (['date','date_time','datetime'].some(it => this.typeInput === it)){
          // return this.updateInputValue();
        }
        this.$emit('input', val)

      },
      blur(e) {
        this.$emit('m-blur', e)
      },

      keyupEnter(e) {
        this.$emit('m-keyup-enter', e)
      },

      focus() {
        this.$refs.RMInput.focus()
      },

      updateInputValue(){
        let  date = moment(this.value);

        if(!date.isValid()){
          date = moment(this.value,toFormats[this.typeInput])
        }
        if(!date.isValid()){
          return ;
        }

        console.log('watch:value',this.value);
        console.log('watch:value:old');
        console.log('watch:value:format',date.format(fromFormats[this.typeInput]));

        this.inputDate = date.format(fromFormats[this.typeInput])
      }
    },

    mounted() {
    },
    computed: {
      cTypeInput() {
        if (this.typeInput === 'date' || this.typeInput === 'date_time') {
          this.dReadOnly = true
          return 'text'
        } else {
          return this.typeInput
        }
      },
      isRequire(){
        const check = (val) => /required/.test(val);
        return Array.isArray(this.validationRules) ?
            this.validationRules.some(check) : check(this.validationRules)
      },
      normalizeValue(){
        if (!['date','date_time','datetime'].some(it => this.typeInput === it)){
          return this.value
        }
        const date = moment(this.value);

        return date.isValid() ? date.format(toFormats[this.typeInput]) : this.value
      }
    },

    watch: {

      inputDate(value) {

        if(!['date','date_time','datetime'].some(val => val === this.typeInput)) return;

        if(!value) return this.$emit('input', '')

        const date = moment(value, fromFormats[this.typeInput]);

        this.$emit('input', date.toDate())
        this.realValue = date.format(toFormats[this.typeInput])
      },
      realValue(value){
        if(['date','date_time','datetime'].some(val => val === this.typeInput)) {
          return;
        }
         this.$emit('input',value)
      },

      value(value, old){

        if(value === old) return;

        if (!['date','date_time','datetime'].some(it => this.typeInput === it)){
          return this.realValue = this.value
        }

        if(!value){
          this.inputDate = null;
        }

        let  date = moment(this.value);

        if(!date.isValid()) return;

        console.log('watch:value:format',date.format(fromFormats[this.typeInput]));

        this.inputDate = date.format(fromFormats[this.typeInput])


      },

    },
  }
</script>

<style lang="stylus">

  .MField
    & .q-field-label {
      color: #666666
    }
</style>
